﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace AccelerometerDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Accelerometer accel;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            
        }

        private void startAccelButton_Click(object sender, RoutedEventArgs e)
        {
            if (accel == null)
            {
                accel = new Accelerometer();
                accel.ReadingChanged += new EventHandler<AccelerometerReadingEventArgs>(accel_ReadingChanged);
                try
                {
                    accelerometerStatusText.Text = "Accelerometer starting.";
                    accel.Start();
                }
                catch (AccelerometerFailedException ex)
                {
                    accelerometerStatusText.Text = "Accelerometer error.";
                }
            }
            else
            {
                try
                {
                    accel.Stop();
                    accel = null;
                    accelerometerStatusText.Text = "Accelerometer Stopped.";
                }
                catch (AccelerometerFailedException ex)
                {
                    accelerometerStatusText.Text = "Error stopping Accelerometer.";
                }
            }
        }

        void accel_ReadingChanged(object sender, AccelerometerReadingEventArgs e)
        {
            Deployment.Current.Dispatcher.BeginInvoke(() => HandleNewReading(e));
        }

        void HandleNewReading(AccelerometerReadingEventArgs e)
        {
            xText.Text = e.X.ToString();
            yText.Text = e.Y.ToString();
            zText.Text = e.Z.ToString();
        }
    }
}