﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Threading;
using Microsoft.Phone.Shell;
using System.Diagnostics;


namespace ExecutionModelTest
{
    public partial class MainPage : PhoneApplicationPage
    {
        private ViewModel vm;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            vm = new ViewModel();
            this.DataContext = vm;
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            if (PhoneApplicationService.Current.StartupMode ==
                StartupMode.Activate)
            {
                
                IDictionary<string, object> state =
                  PhoneApplicationService.Current.State;

                
                if (state.ContainsKey("LastLaunchDate"))
                {
                    Deployment.Current.Dispatcher.BeginInvoke(() =>
                        {
                            vm.LastLaunchDate = (DateTime)state["LastLaunchDate"];
                        });
                }
            }
            else
            {
                Deployment.Current.Dispatcher.BeginInvoke(() =>
                {
                    vm.LastLaunchDate = DateTime.MinValue;
                });
            }
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedFrom(e);

            IDictionary<string, object> state = PhoneApplicationService.Current.State;

            Debug.WriteLine("Navigating away from home page, storing value in tombstone state.");
            
            state["LastLaunchDate"] = DateTime.Now;
        }        
    }
}