﻿using System;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Phone.Controls;

namespace IsolatedStorageDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            
            DataContext = App.ViewModel;
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        private void MainListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // If selected index is -1 (no selection) do nothing
            if (MainListBox.SelectedIndex == -1)
                return;

            (e.AddedItems[0] as ItemViewModel).IsSelected = true;
            if ((e.RemovedItems != null) && (e.RemovedItems.Count > 0))
            {
                (e.RemovedItems[0] as ItemViewModel).IsSelected = false;
            }
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (!App.ViewModel.IsDataLoaded)
            {
                App.ViewModel.LoadData();
            }
        }

        private void appBarAddButton_Click(object sender, EventArgs e)
        {
            Random r = new Random();
            ItemViewModel newItem = 
                new ItemViewModel { Name = "Customer " + r.Next(5, 100).ToString(), 
                    Description = "Newly Created Customer" };
            App.ViewModel.Items.Add(newItem);

            App.ViewModel.SaveToIso();
        }

        private void appBarDelButton_Click(object sender, EventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Delete " + 
                App.ViewModel.Items[MainListBox.SelectedIndex].Name + "?", 
                "Confirm", MessageBoxButton.OKCancel);
            if (result == MessageBoxResult.OK)
            {
                App.ViewModel.Items.RemoveAt(MainListBox.SelectedIndex);
            }

            App.ViewModel.SaveToIso();
        }       
    }
}