﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using SmartClientDemo.ViewModels;
using System.Diagnostics;
using System.IO;
using System.Text;

namespace SmartClientDemo
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();

            // Set the data context of the listbox control to the sample data
            DataContext = App.ViewModel;
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        // Load data for the ViewModel Items
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (!App.ViewModel.VideosLoaded)
            {
                App.ViewModel.LoadVideos();
            }

            //RegularServiceReference.RegularServiceClient client = new RegularServiceReference.RegularServiceClient();
            //client.GetSomeStringCompleted += new EventHandler<RegularServiceReference.GetSomeStringCompletedEventArgs>(client_GetSomeStringCompleted);
            //client.GetSomeStringAsync("foo");
        }

        void client_GetSomeStringCompleted(object sender, RegularServiceReference.GetSomeStringCompletedEventArgs e)
        {
            Debug.WriteLine("Received reply from service:\n" + e.Result);
        }        

        private void Pivot_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (mainPivot.SelectedIndex == 1)
            {
                if (!App.ViewModel.BlogLoaded)
                {
                    App.ViewModel.LoadBlog();
                }
            }
            else if (mainPivot.SelectedIndex == 2)
            {
                if (!App.ViewModel.TweetsLoaded)
                {
                    App.ViewModel.LoadTweets();
                }
            }
        }

        private void BlogListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            // If selected index is -1 (no selection) do nothing
            if (BlogListBox.SelectedIndex == -1)
                return;

            // Navigate to the new page
            NavigationService.Navigate(new Uri("/BlogDetails.xaml?selectedItem=" + BlogListBox.SelectedIndex, UriKind.Relative));

            // Reset selected index to -1 (no selection)
            BlogListBox.SelectedIndex = -1;
            
        }

        private void TweetListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {

        }

        private void foo_Click(object sender, RoutedEventArgs e)
        {            
            HttpWebRequest request = (HttpWebRequest)
                WebRequest.Create(
                "http://localhost/Chapter15ServiceHost/RESTfulService.svc/UploadedCustomers");
            request.ContentType = "text/xml";
            request.Method = "POST";
            request.BeginGetRequestStream(new AsyncCallback(GetRequestStreamCallback), request);            
        }

        void GetRequestStreamCallback(IAsyncResult result)
        {
            HttpWebRequest request = (HttpWebRequest)result.AsyncState;
            Stream postStream = request.EndGetRequestStream(result);

            string xmlPayload =
                "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                    "<Customer xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">" +
                    "<FirstName>Foo</FirstName>" +
                    "<LastName>Johnson</LastName>" +
                    "<Address>" +
                        "<Line1>1 Fake St</Line1>" +
                        "<City>FakeVille</City>" +
                        "<State>FA</State>" +
                        "<Zip>90210</Zip>" +
                    "</Address>" +
                    "</Customer>";
            byte[] payloadBytes = Encoding.UTF8.GetBytes(xmlPayload);
            postStream.Write(payloadBytes, 0, payloadBytes.Length);
            postStream.Close();
            request.BeginGetResponse(new AsyncCallback(GetResponseCallback), request);
        }

        void GetResponseCallback(IAsyncResult result)
        {
            HttpWebRequest request = (HttpWebRequest)result.AsyncState;
            HttpWebResponse response = (HttpWebResponse)request.EndGetResponse(result);
            Stream responseStream = response.GetResponseStream();
            StreamReader streamReader = new StreamReader(responseStream);
            string responseString = streamReader.ReadToEnd();
            Debug.WriteLine(responseString);
            responseStream.Close();
            streamReader.Close();
            response.Close();
        }

        void wcUpload_UploadStringCompleted(object sender, UploadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                Debug.WriteLine(e.Error.ToString());
            }
            else
            {
                MessageBox.Show("Customer successfully uploaded.");
            }
        }
    }
}