﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Runtime.Serialization;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace Mnemuse.Model
{
    [DataContract]
    public class Book
    {
        [DataMember]
        public string Title { get; set; }

        [DataMember]
        public string Description { get; set; }

        [DataMember]
        public Guid ID { get; set; }
    }

    public static class BookExtensions
    {
        public static Book[] ToModelArray(this ObservableCollection<ViewModel.Book> sourceBooks)
        {
            List<Book> bookList = new List<Book>();
            if (sourceBooks != null)
            {
                foreach (ViewModel.Book book in sourceBooks)
                    bookList.Add(new Book { ID = book.ID, Description = book.Description, Title = book.Title });
            }
            return bookList.ToArray();
        }

        public static ViewModel.Book[] ToViewModel(this IEnumerable<Book> sourceBooks)
        {
            List<ViewModel.Book> bookList = new List<ViewModel.Book>();
            if (sourceBooks != null)
            {
                foreach (Book book in sourceBooks)
                    bookList.Add(new ViewModel.Book { ID = book.ID, Title = book.Title, Description = book.Description });
            }
            return bookList.ToArray();
        }
    }
}
