﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Runtime.Serialization;
using System.Collections.Generic;

namespace Mnemuse.Model
{
    [DataContract]
    public class Character
    {
        [DataMember]
        public string Name { get; set; }        
    }

    public static class CharacterExtensions
    {
        public static Character[] ToModelArray(this IList<ViewModel.Character> sourceChars)
        {
            List<Character> charList = new List<Character>();
            if (sourceChars != null)
            {
                foreach (ViewModel.Character vmChar in sourceChars)
                {
                    charList.Add(new Character { Name = vmChar.Name });
                }
            }
            return charList.ToArray();
        }

        public static ViewModel.Character[] FromModelArray(this Character[] sourceChars)
        {
            List<ViewModel.Character> vmChars = new List<ViewModel.Character>();
            if (sourceChars != null)
            {
                foreach (Character modelChar in sourceChars)
                {
                    vmChars.Add(new ViewModel.Character { Name = modelChar.Name });
                }
            }
            return vmChars.ToArray();
        }
    }
}
