﻿using System;
using Mnemuse.Model;
using System.Collections.Generic;

namespace Mnemuse.Tests.Mocks
{
    public class MockMnemuseServiceProvider : IMnemuseServiceProvider
    {
        private List<Book> bookList;
        private List<Character> characterList;

        public MockMnemuseServiceProvider()
        {
            bookList = new List<Book>();
            bookList.Add(new Book { ID = Guid.NewGuid(), Title = "Mock Book 1", Description = "Mock Book Number 1" });
            bookList.Add(new Book { ID = Guid.NewGuid(), Title = "Mock Book 2", Description = "Mock Book Number 2" });

            characterList = new List<Character>();
            characterList.Add(new Character { Name = "Mock Character 1" });
            characterList.Add(new Character { Name = "Mock Character 2" });
            characterList.Add(new Character { Name = "Mock Character 3" });
        }

        public void SaveCharacters(Guid bookId, System.Collections.Generic.IEnumerable<Character> characters)
        {
            characterList.Clear();
            characterList.AddRange(characters);
        }

        public System.Collections.Generic.IEnumerable<Character> LoadCharacters(Guid bookId)
        {
            return characterList.ToArray();
        }

        public void SaveBooks(System.Collections.Generic.IEnumerable<Book> books)
        {
            bookList.Clear();
            bookList.AddRange(books);
        }

        public System.Collections.Generic.IEnumerable<Book> LoadBooks()
        {
            return bookList.ToArray(); 
        }
    }
}
