﻿using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GalaSoft.MvvmLight.Messaging;
using Mnemuse.Messages;
using Mnemuse.ViewModel;
using System.Diagnostics;

namespace Mnemuse.Tests.Tests
{
    [TestClass]
    public class BookTest : SilverlightTest
    {
        [ClassInitialize]
        public void Init()
        {
        }

        [TestMethod]
        [Asynchronous]
        public void RemoveCommandExecuteSendsMessage()
        {
            Book b = new Book();

            Messenger.Default.Register<RemoveBookMessage>(this,
                (m) => {
                    Debug.WriteLine("Received book removal message from Book view model.");
                    Assert.AreEqual(b, m.Book);
                    EnqueueTestComplete();
                });
            
            b.RemoveBookCommand.Execute(null);           
        }

        [ClassCleanup]
        public void Cleanup()
        {
        }
    }
}
