﻿using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Mnemuse.ViewModel;
using Mnemuse.Model;
using Mnemuse.Tests.Mocks;

namespace Mnemuse.Tests.Tests
{
    [TestClass]
    public class MainViewModelTest : SilverlightTest
    {
        private MainViewModel main;
        private IMnemuseServiceProvider dummyProvider;
        
        [ClassInitialize]
        public void Init()
        {
            dummyProvider = new MockMnemuseServiceProvider();
            ViewModelLocator.ServiceProvider = dummyProvider;
            ViewModelLocator.CreateMain();
            main = ViewModelLocator.MainStatic;
        }

        [ClassCleanup]
        public void Cleanup()
        {
            main.Cleanup();
            main = null;
        }

        [TestMethod]
        [Description("Verifies that executing the AddBookCommand adds a book to book list")]
        public void AddCommandExecuteAddsBook()
        {
            // Arrange
            int oldBookCount = main.Books.Count;

            // Act
            main.AddBookCommand.Execute(null);

            // Assert
            Assert.AreEqual(oldBookCount + 1, main.Books.Count);
            // We know our dummy provider started with 2 books, make sure that didn't change somehow
            Assert.AreEqual(2, oldBookCount);
        }
    }
}
