﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace Mnemuse.Model
{
    public class MnemuseServiceProvider : IMnemuseServiceProvider
    {

        public void SaveCharacters(Guid bookId, IEnumerable<Character> characters)
        {            
            IsoStoreHelper.WriteGraphToFile(bookId.ToString() + "-chars.dat", characters);
        }

        public IEnumerable<Character> LoadCharacters(Guid bookId)
        {
            return IsoStoreHelper.ReadGraphFromFile<Character[]>(bookId.ToString() + "-chars.dat");
        }

        public void SaveBooks(IEnumerable<Book> books)
        {
            IsoStoreHelper.WriteGraphToFile("books.dat", books);
        }

        public IEnumerable<Book> LoadBooks()
        {
            return IsoStoreHelper.ReadGraphFromFile<Book[]>("books.dat");
        }
    }
}
